/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gebietsbaum;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gebietsbaum.boundary.AbstractGebietsarteigenschaftSearchParameters;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftSearch;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsarteigenschaftSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft;
import de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractGebietsarteigenschaftSearchView.COMPONENT_NAME)
@View(viewId = AbstractGebietsarteigenschaftSearchView.VIEW_ID, useCase = UseCasePermission.GEBIETSARTEIGENSCHAFT_SEARCH)
public abstract class AbstractGebietsarteigenschaftSearchView extends AbstractElectSearchView<Gebietsarteigenschaft> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsarteigenschaftSearchView";
  
  public static final String VIEW_ID = "/gebietsbaum/gebietsarteigenschaft-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractGebietsarteigenschaftSearchView requestHandler;

  @Inject
  private transient GebietsarteigenschaftExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(GebietsarteigenschaftConversationStore.class)
  protected transient GebietsarteigenschaftConversationStore conversationStore;

  @Inject
  protected transient GebietsarteigenschaftSearch search;

  @Inject
  @ConversationGroup(AbstractGebietsarteigenschaftSearchParameters.class)
  protected transient GebietsarteigenschaftSearchParameters searchParameters;

  @Inject
  protected transient GebietsarteigenschaftMeta entityMeta;

  public AbstractGebietsarteigenschaftSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Gebietsarteigenschaft getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Gebietsarteigenschaft entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public GebietsarteigenschaftSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Gebietsarteigenschaft> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Gebietsarteigenschaft> create();
  }

  @Override
  public List<Gebietsarteigenschaft> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Gebietsarteigenschaft> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onGebietsarteigenschaftChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietsarteigenschaftChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractGebietsarteigenschaftSearchView {

    @View
    @Inject
    private transient Instance<AbstractGebietsarteigenschaftSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractGebietsarteigenschaftSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
